/**** A P P L I C A T I O N   N O T E   ************************************
*
* Title			: DMX-Input for RGBW-LED Control
* Version		: v4.3
* Last updated	: 03.08.2010
* Target		: PC_DIMMER DMX-RGBW-LED Control [ATtiny2313]
* Clock			: 8MHz
*
* Written by Christian Noeding, http://www.pcdimmer.de
***************************************************************************
 This program is free software; you can redistribute it and/or 
 modify it under the terms of the GNU General Public License 
 as published by the Free Software Foundation; either version2 of 
 the License, or (at your option) any later version. 

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 General Public License for more details. 

 If you have no copy of the GNU General Public License, write to the 
 Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

 For other license models, please contact the author.

;***************************************************************************/
#include "main.h"

const uint8_t TABLE[] PROGMEM =	{
	0, 11, 15, 17, 20, 22, 24, 27, 29, 30, 32, 33, 35, 36, 38, 39,
	40, 42, 43, 44, 45, 46, 47, 48, 50, 51, 52, 53, 54, 55, 56, 57,
	58, 59, 59, 60, 61, 62, 63, 64, 65, 66, 66, 67, 68, 69, 70, 70,
	71, 72, 73, 74, 74, 75, 76, 77, 77, 78, 79, 80, 80, 81, 82, 83,
	84, 84, 85, 86, 86, 87, 88, 88, 89, 90, 90, 91, 92, 92, 93, 94,
	94, 95, 96, 96, 97, 98, 98, 99,100,100,101,102,102,103,104,104,
	105,106,106,107,108,108,109,109,110,111,111,112,113,113,114,114,
	115,116,116,117,118,118,119,119,120,121,121,122,123,123,124,124,
	125,126,126,127,127,128,129,129,130,131,131,132,132,133,134,134,
	135,136,136,137,137,138,139,139,140,141,141,142,142,143,144,144,
	145,146,146,147,148,148,149,150,150,151,152,152,153,154,154,155,
	156,156,157,158,158,159,160,160,161,162,162,163,164,164,165,166,
	166,167,168,169,170,170,171,172,173,173,174,175,176,176,177,178,
	179,180,180,181,182,183,184,184,185,186,187,188,189,190,191,191,
	192,193,194,195,196,197,198,199,200,202,203,204,205,206,207,208,
	210,211,212,214,215,217,218,220,221,223,226,228,230,233,235,255
};

void init_PWM(void)
{  
  // Timer 0 PWM Init
  TCCR0A = (1 << WGM00) // PWM, Phase Correct (Triangular)
         | (1 << COM0A1) // Set ORC0A on Compare Match on CountUp, Clear on Compare Match on CountDown
         | (1 << COM0B1); // Set ORC0B on Compare Match on CountUp, Clear on Compare Match on CountDown
  TCCR0B = (1 << CS00); // No Prescaling (->8Mhz)

  // OC0A PWM Port
  DDRB   |= (1 << PB2);
  OCR0A = 0;

  // OC0B PWM Port
  DDRD   |= (1 << PD5);
  OCR0B = 0;
  
  // Timer 1 PWM Init
  TCCR1A = (1 << WGM10) // PWM, Phase Correct (Triangular) 8-Bit
         | (1 << COM1A1) // Set OC1A on Compare Match on CountUp, Clear on Compare Match on CountDown
         | (1 << COM1B1); // Set OC1B on Compare Match on CountUp, Clear on Compare Match on CountDown
  TCCR1B = (1 << CS10); // No Prescaling (->8Mhz)

  // OC1A PWM Port
  DDRB   |= (1 << PB3);
  OCR1AL = 0;

  // OC1B PWM Port
  DDRB   |= (1 << PB4);
  OCR1BL = 0;
}

void update_PWM(void)
{
	pwm1 = pgm_read_byte(TABLE +DmxField[0]);
	pwm2 = pgm_read_byte(TABLE +DmxField[1]);
  	pwm3 = pgm_read_byte(TABLE +DmxField[2]);
	pwm4 = pgm_read_byte(TABLE +DmxField[3]);
}
