// Includings
#include <ctype.h>
#include <util/delay.h>
#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>

// Definitionen
#define F_CPU 8000000UL     					//Quarz mit 8.000 Mhz
#define DMX_CHANNELS    (4)						//use 4ch
#define F_OSC			(8000)		  			//oscillator freq. in kHz (typical 8MHz or 16MHz)

// PWM Register definieren
#define pwm1 OCR0A
#define pwm2 OCR0B
#define pwm3 OCR1AL
#define pwm4 OCR1BL

// Variablendefinitionen
uint8_t				i;
uint8_t				count;
volatile uint8_t	DmxField[DMX_CHANNELS];		//array of DMX vals (raw)
uint8_t				DmxOldField[DMX_CHANNELS];	//array of DMX vals (to check if new data was received)
uint8_t				DmxValueChanged;
volatile uint16_t	DmxAddress;					//start address
volatile uint8_t	DmxAlive;					//Zhler fr DMX-Lost-Erkennung
volatile uint8_t	Catched511;
volatile uint8_t	Catched512;
volatile uint8_t	NewAddressAbove255;
volatile uint8_t	GetNewDMXAddress;

#define TRUE 1
#define FALSE 0

// Funktionsprototypen
extern void init_DMX(void);
extern void init_PWM(void);
extern void update_PWM(void);

// GPIO Konfigurieren
#define TASTER				PD6
#define LEDYELLOW			PD3
#define	LEDGREEN			PD4

// GPIO Funktionen definieren
#define ledYellowOn()    	PORTD |= (1<<LEDYELLOW)
#define ledYellowOff()   	PORTD &=~(1<<LEDYELLOW)
#define ledYellowToggle()	PORTD ^= (1<<LEDYELLOW)
#define ledGreenOn()  		PORTD |= (1<<LEDGREEN)
#define ledGreenOff() 		PORTD &=~(1<<LEDGREEN)
#define ledGreenToggle()	PORTD ^= (1<<LEDGREEN)
